#include <stdlib.h>
#include <winsock2.h>
#include <stdio.h>
#include <conio.h>

typedef BYTE _u8;
typedef WORD _u16;
typedef DWORD _u32;

#define EZTCP_ERR		-1
#define	EZTCP_ERR_PWD	-100
#define	EZTCP_ERR_RES	-200

#define MK_IP(__b1,__b2,__b3,__b4) \
( ((unsigned long)(__b4) << 24) | ((unsigned long)(__b3) << 16) | \
  ((unsigned long)(__b2) <<  8) | ((unsigned long)(__b1)) )

//================================================
struct pseudo_etc_opt
{
	_u8 comment[32];
};

struct etc_opt
{
	_u8 comment[32];
	_u8 ext_opt[32];
	_u8 opt[20];
};
//================================================

//==================================
struct pseudo_wlan_env
{
	unsigned int cctype;		/* Connection Control Type */
	unsigned int channel;		/* Channel	*/
	unsigned int wep;			/* 0 - NO WEP, 1- 64BIT, 2- 128BIT */
	unsigned int wep_id;		/* 0, 1, 2, 3 */
	unsigned int cfg_ahc;
	unsigned int cfg_ifs;
	unsigned int auth;			/* Open System(0), Shared Key(1) */	
	unsigned int pad1;
	unsigned int pad2;
	_u8 pad3[12];
	_u8 target_ssid[32];		/* 48 */
	_u8 new_ssid[32];			/* 80 */
	_u8 key64[4][6];			/* 104 */ /* 5bytes key - total 24bytes */
	_u8 key128[4][14];			/* 160 */ /* 13bytes key - total 56bytes */
};

struct wlan_env
{
	unsigned int cctype		: 4;		/* Connection Control Type */
	unsigned int channel	: 4;		/* Channel	*/
	unsigned int wep		: 2;		/* 0 - NO WEP, 1- 64BIT, 2- 128BIT */
	unsigned int wep_id		: 2;		/* 0, 1, 2, 3 */
	unsigned int cfg_ahc	: 1;
	unsigned int cfg_ifs	: 1;
	unsigned int auth		: 2;		/* Open System(0), Shared Key(1) */			
	unsigned int pad1		: 8;
	unsigned int pad2		: 8;		/*	4 */
	_u8 pad3[12];						/* 16 */
	_u8 target_ssid[32];				/* 48 */
	_u8 new_ssid[32];					/* 80 */
	_u8 key64[4][6];					/* 104 */ /* 6bytes key - total 24bytes */
	_u8 key128[4][14];					/* 160 */ /* 13bytes key - total 56bytes */
};
//==================================

struct pseudo_spe_env
{
	_u8 config[4];
	_u8 eth_addr[6];
	_u8 secure[18];

	unsigned int level;
	unsigned int eap_lock;
	unsigned int en_xonoff;
	unsigned int ezl50;
	unsigned int dhcp_lock;
	unsigned int pppoe_lock;
	unsigned int to_lock;
	unsigned int lp_lock;
	unsigned int rp_lock;
	unsigned int wm_lock;
	unsigned int rip_lock;
	unsigned int en_databit;
	unsigned int en_parity;
	unsigned int major;   
	unsigned int minor;   


	unsigned int dhcp;
	unsigned int bootp;
	unsigned int arp;
	unsigned int ssl;
	unsigned int ezcfg;
	unsigned int nat;
	unsigned int pppoe;
	unsigned int stat;
	unsigned int arp_probe;
	unsigned int max_mux;
	unsigned int eapol;
	unsigned int t2s_peer;
	unsigned int pwr_down;
	unsigned int en_rcfg;
	unsigned int rcfg;
	unsigned int comment;
	unsigned int pad2a;
	unsigned int pad2b;

	_u32 local_ip;             
	_u32 net_mask;             
	_u32 gate_ip;
	_u8  poe_uid3[16];         
	_u8  poe_uid2[8];
	_u8  passwd[12];           

	unsigned int parity;
	unsigned int databit;
	unsigned int rtscts;
	unsigned int xonoff;
	unsigned int telnet;
	unsigned int http;
	unsigned int fcs;
	unsigned int seq_ack;
	unsigned int hdlc_emu;
	unsigned int logo;
	unsigned int oem;
	unsigned int wlancfg;
	unsigned int stype;
	unsigned int stopbit;
	unsigned int t2smc;
	unsigned int parity2;
	unsigned int slow_tx;
	unsigned int pad3b;
	
	_u32 sio_baud;            
	_u32 timeout;             
	_u8  mux_type;            
	_u8  mux_pad;             
	_u32 water_mark;          
	_u16 pad4;                
	_u32 remote_ip;           
	_u32 remote_port;         
	_u32 local_port;          
	_u8  poe_uid[8];         
	_u8  poe_pwd[8];         
	_u32 id;
};

struct spe_env
{
	/* basic secure section*/
	_u8 config[4];             
	_u8 eth_addr[6];				//ethernet address     
	_u8 secure[18];            
	unsigned int level  : 4;

	//==================================
	unsigned int eap_lock  : 1;
	unsigned int en_xonoff	: 1;
	//==================================

	unsigned int ezl50     : 1;		// EZL50 only 
	unsigned int dhcp_lock : 1;		// EZL50 only 
	unsigned int pppoe_lock: 1;		// EZL50 only 
	
	//==================================
	unsigned int to_lock   : 1;/* EZL50: timeout lock */
	unsigned int lp_lock   : 1;/* EZL50: local port lock */
	unsigned int rp_lock   : 1;/* EZL50: remote port lock */
	unsigned int wm_lock   : 1;/* EZL50: water mark lock */
	unsigned int rip_lock  : 1;/* EZL50: remote ip lock */
	unsigned int en_databit: 1;/* EZL50: enable databit combo box of ezcfg */
	unsigned int en_parity : 1;/* EZL50: enable parity combo box of ezcfg */
	//==================================

	/* version section */
	unsigned int major  : 8;   
	unsigned int minor  : 8;   

	/* network section */
	unsigned int dhcp   : 1;
	unsigned int bootp	: 1;
	unsigned int arp	: 1;
	unsigned int ssl	: 1;
	unsigned int ezcfg  : 1;
	unsigned int nat    : 1;
	unsigned int pppoe  : 1;
	unsigned int stat   : 1;
	//==================================
	unsigned int arp_probe : 1;
	unsigned int max_mux   : 3;
	unsigned int eapol     : 2;		/* 0 - disable, 1 - MD5, ... */
	unsigned int t2s_peer  : 1;
	unsigned int pwr_down  : 1;		/* for wlan product */
	//==================================

	//==================================
	// 2005 09 23 hjkim
	// new option add.
	unsigned int en_rcfg   : 1;
	unsigned int rcfg	   : 1;
	unsigned int comment   : 1;
	unsigned int pad2a	   : 5;		/* 35 */
	unsigned int pad2b	   : 8;     /* 36 */
	//==================================

	_u32 local_ip;             
	_u32 net_mask;             
	_u32 gate_ip;              
	_u8  poe_uid3[16];         
	_u8  poe_uid2[8];          
	_u8  passwd[12];           

	/* mux/sio section */
	unsigned int parity  : 2;	/* 0 - none, 1 - even, 2 - odd, 3 - parity2*/
	unsigned int databit : 4;
	unsigned int rtscts  : 1;
	unsigned int xonoff  : 1;
	unsigned int telnet  : 1;
	unsigned int http    : 1;		// not used 
	unsigned int fcs     : 1;		// check HDLC fcs ? 
	unsigned int seq_ack : 1;		// seq / ack negoitiation? : not used 
	unsigned int hdlc_emu: 1;		// HDLC emulation : not used 
	unsigned int logo    : 1;		// telnet/console logo switch 
	//==================================
	unsigned int oem     : 1;
	unsigned int wlancfg : 1;
	unsigned int stype   : 2;  /* serial type : 0(232), 1(422), 2(485) */
	unsigned int stopbit : 2;  /* 0(1stopbit), 1(2stopbit) */
	unsigned int t2smc   : 1;
	unsigned int parity2 : 2;  /* 0 - mark, 1 - space */
	unsigned int slow_tx : 1;
	unsigned int pad3b   : 8; /*  88 */
	//================================== 
	_u32 sio_baud;            
	_u16 timeout;             
	_u8  mux_type;            
	_u8  mux_pad;             
	_u16 water_mark;          
	_u16 pad4;                
	_u32 remote_ip;           
	_u16 remote_port;         
	_u16 local_port;          
	_u8  poe_uid[8];         
	_u8  poe_pwd[8];         
	_u32 id;                 
};
//====================================================

//====================================================
struct pseudo_stat_env
{
	_u8 	ver[8];
	_u8		freq[6];
	_u8		boot_ver[8];
	_u8		mac_addr[6];
	_u8		ip_addr[4];
	_u8		sub_mask[4];
	_u8		gate_addr[4];
	unsigned int		uptime_day;
	unsigned int		uptime_hour;
	unsigned int		uptime_minute;
	unsigned int		uptime_second;
	long unsigned int	sio_rx;
	long unsigned int	sio_tx;
	long unsigned int	eth_rx;
	long unsigned int	eth_tx;
	unsigned int		eth_crc;
	unsigned int		eth_align;
	unsigned int		eth_lost;
	char				text[256];	
};

struct stat_env
{
	_u8 	ver[8];
	_u8		freq[6];
	_u8		boot_ver[8];
	_u8		mac_addr[6];
	_u8		ip_addr[4];
	_u8		sub_mask[4];
	_u8		gate_addr[4];
	unsigned int		uptime_day;
	unsigned int		uptime_hour;
	unsigned int		uptime_minute;
	unsigned int		uptime_second;
	long unsigned int	sio_rx;
	long unsigned int	sio_tx;
	long unsigned int	eth_rx;
	long unsigned int	eth_tx;
	unsigned int		eth_crc;
	unsigned int		eth_align;
	unsigned int		eth_lost;
	char				text[256];
};
//====================================================

int __stdcall ProbeEzTCP(struct pseudo_spe_env * pseudo_eztcpenv, struct pseudo_wlan_env * pseudo_eztcpwenv, struct pseudo_etc_opt * pseudo_eztcpopt, int * nResultCount, int *nErrNum);
int __stdcall WriteEzTCP(struct pseudo_spe_env * pseudo_eztcpenv, struct pseudo_wlan_env * pseudo_eztcpwenv, struct pseudo_etc_opt * pseudo_eztcpopt, int *nErrNum);
int __stdcall StatusEzTCP(struct pseudo_spe_env * pseudo_eztcpenv, struct pseudo_stat_env * pseudo_eztcpstat, int *nErrNum);
int __stdcall ChangePwdEzTCP(struct pseudo_spe_env * pseudo_eztcpenv, const char * ChangePwd, int *nErrNum);
char* __stdcall GetLibVerEzTCP();

// remote config function
int __stdcall RemoteChangePwdEzTCP(DWORD ip, struct pseudo_spe_env * pseudo_eztcpenv, const char * ChangePwd, int *nErrNum);
int __stdcall RemoteReadEzTCP(DWORD ip, struct pseudo_spe_env * pseudo_eztcpenv, struct pseudo_wlan_env * pseudo_eztcpwenv, struct pseudo_etc_opt * pseudo_eztcpopt, int * nResultCount, int *nErrNum);
int __stdcall RemoteStatusEzTCP(DWORD ip, struct pseudo_spe_env * pseudo_eztcpenv, struct pseudo_stat_env * pseudo_eztcpstat, int *nErrNum);
int __stdcall RemoteWriteEzTCP(DWORD ip, struct pseudo_spe_env * pseudo_eztcpenv, struct pseudo_wlan_env * pseudo_eztcpwenv, struct pseudo_etc_opt * pseudo_eztcpopt, int *err);

int __stdcall CloseTCP(struct pseudo_spe_env * pseudo_eztcpenv, const char * Pwd, int *nErrNum);
int __stdcall ResetEzTCP(struct pseudo_spe_env * pseudo_eztcpenv, const char * Pwd, int *nErrNum);
int __stdcall RemoteCloseTCP(DWORD ip, struct pseudo_spe_env * pseudo_eztcpenv, const char * Pwd, int *nErrNum);
int __stdcall RemoteResetEzTCP(DWORD ip, struct pseudo_spe_env * pseudo_eztcpenv, const char * Pwd, int *nErrNum);